#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFortuenShopCFG.h"
std::auto_ptr<M_ActivityFortuenShopCFG> M_ActivityFortuenShopCFG::msSingleton(nullptr);

int M_ActivityFortuenShopCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFortuenShopCFGData* M_ActivityFortuenShopCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFortuenShopCFGData>& M_ActivityFortuenShopCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityFortuenShopCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFortuenShopCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFortuenShopCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItemName = element->Attribute("ItemName");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCont = element->IntAttribute("ItemCont");
		data.mExchangeId = element->IntAttribute("ExchangeId");
		data.mExchangeCount = element->IntAttribute("ExchangeCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFortuenShopCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFortuenShopCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFortuenShopCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFortuenShopCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFortuenShopCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "ItemName", data.mItemName);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCont", data.mItemCont);
		LuaCfgHelper::readInt(L, "ExchangeId", data.mExchangeId);
		LuaCfgHelper::readInt(L, "ExchangeCount", data.mExchangeCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFortuenShopCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFortuenShopCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFortuenShopCFG* M_ActivityFortuenShopCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFortuenShopCFG());
	}
	return msSingleton.get();
}

void M_ActivityFortuenShopCFG::Release()
{
	msSingleton.reset(nullptr);
}
